<?php
//関数を呼び出す際に$widthと$heightは省略可能（省略すると250になる）
function createThumb($filename,$width=250,$height=250){
	if(!file_exists($filename)){
		//ファイルが存在しない場合はエラー
		return false;//関数を終了させる
	}
	list($imgwidth,$imgheight) = getimagesize($filename);//指定した画像の幅と高さを取得して、$imgwidthと$imgheightに入れる
	$thumb_filename = str_replace('.','_thumb.',$filename);//str_replaceで「.」を「_thumb.」としてファイル名を生成
	copy($filename,$thumb_filename);//ファイルをコピーする
	if(($width > $imgwidth) && ($height > $imgheight)){
		//画像のサイズがサムネイルサイズよりも小さい→処理が不要
		return $thumb_filename;//正常終了
	}
	if($imgwidth > $imgheight){
		//横長画像である
		$nWidth = $width;//新しい横幅サイズを指定
		$nHeight = $imgheight / ($imgwidth / $width);//縦横比を維持したまま高さを縮小する
	}
	else{
		//縦長画像である
		$nWidth = $imgwidth / ($imgheight / $height);
		$nHeight = $height;
	}
	$img = imagecreatetruecolor($nWidth,$nHeight);//幅と高さを指定して透明なカンバスを作成する
	$type = exif_imagetype($thumb_filename);//画像形式を取得
	if($type === IMAGETYPE_JPEG){
		$src = imagecreatefromjpeg($thumb_filename);
		//JPEG画像を取ってくる
		imagecopyresized($img,$src,0,0,0,0,$nWidth,$nHeight,$imgwidth,$imgheight);//画像をリサイズする
		imagejpeg($img,$thumb_filename);//JPEG画像として保存する
	}
	elseif($type === IMAGETYPE_GIF){
		$src = imagecreatefromgif($thumb_filename);
		imagecopyresized($img,$src,0,0,0,0,$nWidth,$nHeight,$imgwidth,$imgheight);
		imagegif($img,$thumb_filename);//GIF画像として保存
	}
	elseif($type === IMAGETYPE_PNG){
		$src = imagecreatefrompng($thumb_filename);
		imagecopyresized($img,$src,0,0,0,0,$nWidth,$nHeight,$imgwidth,$imgheight);
		imagepng($img,$thumb_filename);//PNG画像として保存
	}
	return $thumb_filename;//サムネイルのファイル名を返す
}
?>